;******************************************************************************
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    I (Simon Wood) can be contacted via email - unilink@mungewell.org
;    or via post - 14 Kirklands Close, Baildon, West Yorkshire, England.
;
;******************************************************************************
;	Additional Info - Release version  1.8T_03
;		Modified Version : GNUnilink for MDX-5V101R
;			"Released under the GPL license, 
;					(c) H "Turboh" Ishimoto, June 2004"
;					   Email: ishimoto@bea.hi-ho.ne.jp
;******************************************************************************

; Work out which 'command' we have received and issue the appropriate response

Interpret:
	movf	Cmd1, 0			;; [10db00xx] Ejecting Check	
	xorlw	0x00			;;    for MDX-5V101R  Jul. 24 2004 (T)
	btfsc	STATUS, Z		;;
	goto	PongEject		;;

	movf	Cmd1, 0
	xorlw	0x01
	btfsc	STATUS, Z
	goto	Cmd1_was_01

	movf	Cmd1, 0
	xorlw	0x02
	btfsc	STATUS, Z
	goto	Respond_Appoint

	movf	Cmd1, 0
	xorlw	0x20
	btfsc	STATUS, Z
	goto	Cmd_Selected

	movf	Cmd1, 0
	xorlw	0x80			;;Display shows [18,xx,80,xx]
	btfsc	STATUS, Z
	goto	Cmd_DSP_Shows

;;----Power ON/OFF------------
	movf	Cmd1, 0
	xorlw	0x87			;;sys down[878a,876b,8792]
	btfsc	STATUS, Z
	goto	Cmd_PowerOff

	movf	Cmd1, 0
	xorlw	0xF0			;;switch source
	btfsc	STATUS, Z
	goto	Cmd_Deselected


;;---NEXT NEXT- AS button remap to Next Disk
	movf	Cmd1, 0
	xorlw	0x29			;;for MDX-5V101R [0x2960] AS pressed
	btfsc	STATUS, Z
	goto	But_Next

	IFDEF	DEBUG
;;--------------------------
	movf	Cmd1, 0
	xorlw	0x50			;;for MDX-61 [0x5000] Enter pressed
	btfsc	STATUS, Z
	goto	But_Next_Test
;;--------------------------
	ENDIF	;; <DEBUG>

	movf	Cmd1, 0			;;Current disk number monitoring
	xorlw	0x90			;;[0x70,id,90,xx,xx,xx,xx,Nx]
	btfsc	STATUS, Z		;;
	goto	Current_DiscP		;;

	movf	Cmd1, 0			;;Current disk number monitoring
	xorlw	0xc0			;;[0x70,id,c0,xx,xx,xx,xx,xx,
	btfsc	STATUS, Z		;;	xx,xx,xx,xx,Nx]
	goto	Current_Disc3

	movf	Cmd1, 0			;;Magazine Info.
	xorlw	0x95			;;[0x70,id,95,xx,xx,xx,xx,xN]
	btfsc	STATUS, Z
	goto	Magazine_Info

	movf	Cmd1, 0			;; Direct Disc Button monitor
	xorlw	0x3c			;; [0x10,21,3c,Na] 
	btfsc	STATUS, Z		;; 
	goto	DDirNum_Store


	IFDEF	SUP_ExDTname
;;----------------------------------
	ELSE
;;----------------------------------
	movf	Cmd1, 0			;; Request to send Extra Disc/Track Name
	xorlw	0x84			;; [d1,71,84,dd/d9,70,(field),00,02] 
	btfsc	STATUS, Z		;; 
	goto	ExtraNam_Req		;;
;;----------------------------------
	ENDIF 	;;<SUP_ExDTname>

	goto	ReceiveBreak		; Unknown command


Cmd1_was_01:
	movf	Cmd2, 0
	btfsc	STATUS, Z			; Check for 'Init'
	goto	WarmBoot

	movf	Cmd2, 0
	xorlw	0x02				; Check for 'Anyone'
	btfsc	STATUS, Z
	goto	Respond_Anyone

	movf	Cmd2, 0
	xorlw	0x11				; Check for 'Alive'
	btfsc	STATUS, Z
	goto	Respond_Hello

	movf	Cmd2, 0
	xorlw	0x12				; Check for 'Ping'
	btfsc	STATUS, Z
	goto	Respond_Ping

	movf	Cmd2, 0
	xorlw	0x13				; Check for 'Slave Poll'
	btfsc	STATUS, Z
	goto	Respond_SlavePoll

	movf	Cmd2, 0
	xorlw	0x15				; Check for 'Master Poll'
	btfsc	STATUS, Z
	goto	Respond_MasterPoll


	IFDEF	CdMd_SW
;;-------------------------------------	;; no statement
	ELSE	;; <IFNDEF  CdMd_SW>
;;------------------------------------	;;in CD/MD Auto select mode
	movf	Cmd2, 0			;;[xx,10.01,0f] "No ID resource "
	xorlw	0x0f			;; Check for "No Resource"
	btfsc	STATUS, Z
	goto	Respond_ReconfReq	
;;-------------------------------------
	ENDIF	;; <CdMd_SW>

	goto	ReceiveBreak			; Unknown command


Cmd_Selected:
;;--- Added checking if Tad is Master. (T)
	movf	Tad, 0			;; 
	xorlw	0x10			;; Is Tad Master?
	btfss	STATUS, Z	
	goto	ReceiveBreak		;; If not, ignore

	movf	Rad, 0			;; 
	subwf	MyId, 0			;; Is Rad MyID?
	btfsc	STATUS, Z
	goto	Cmd_Selected2		;; (MyID)

	call	Play_Stop		;; Stop playing if Rad is not MyID.
	goto	ReceiveBreak		;;

Cmd_Selected2:
	clrf	PowDown			;; set PowerON. (T)
	clrf	DropCheckCount		;; clear DropCheckCount

	clrf	Ej_announceF		;; set Ej_announceF=0 ;Jul 25 2004 (T)

	movlw	DispCtrl_DcName		;; set DispCtrl (=0x0d)
	movwf	DispCtrl		;;

	movlw	0x01			; Restart the display sequence
	movwf	Display

	bsf	ResPeriod, 0		;; (set ResPeriod = 1)
	call	IssueSlaveBreak		;;

	goto	ReceiveBreak

Cmd_PowerOff:				;;[0x87**]
	call	Int_Reset
	call	Play_Stop		;; Stop Playing.
	call	Waitfor15
	call	Play_Stop		;; retry
	bsf	PowDown, 0		;; (set =1) PowerDown!!

;; --- 0x8792 : stop -> sleep		;; Jan. 30 2004  (T)
;; --- 0x8713 : stop -> sleep		;; Jan. 30 2004  (T)
;; --- 0x8793 : play -> sleep		;; Jan. 30 2004  (T)
;; --- 0x8722 : BusConfig -> sleep	;; Jan. 31 2004  (T)
;; --- 0x8712 : play -> sleep		;; Jan. 31 2004  (T)
;; --- 0x8732 : -- -> sleep		;; Jan. 31 2004  (T)

	movf	Cmd2, 0
	andlw	0x0f			;; Cmd2 = 0xX2 
	xorlw	0x02			;;
	btfsc	STATUS, Z			
	goto	Cmd_PowerOff2

	movf	Cmd2, 0
	andlw	0x0f			;; Cmd2 = 0xX3
	xorlw	0x03			;;
	btfsc	STATUS, Z			
	goto	Cmd_PowerOff2

	goto	ReceiveBreak2		;; (stopper)

Cmd_PowerOff2:				;;[0x87*2,3] (sys down)  (T)
;; --- Wait for 0.1sec,  and watch the BusOn line goes Low.
	call	Waitfor100ms		;; wait for 0.1s
	btfsc	OUT_PORT, BusOnBit	; Test for BusOn being low
	goto	Cmd_PowerOff2		;; (High) retry.
	
;; --- Configure RB0/INT setting
	call	Int_Reset

	bsf	STATUS, RP0		;; go Bank1
	nop
	bsf	OPTION_REG, INTEDG	;; INTEDG=1

	bsf	TRISB, 0		;; set RB0/INT=1 (bit0) as input
					;;    Modified  Feb. 14 2004 (T)
	bcf	STATUS, RP0		;; go Bank0
	movlw	0x07
	movwf	CMCON			;; disable Comparator

	bcf	PORTB, 0		;;-- Modified  Feb. 14 2004 (T)> --
	bcf	INTCON, INTF		;; clear RB0/INT flag
	nop
	bsf	INTCON, INTE		;; enable RB0/INT
	nop
	bsf	INTCON, GIE		;; enable GIE

;;--- Go Sleep
;;RB0/INT interrupt will cause some instructions after wakeup.  (T)
;;    (while the 2nd or 3rd NOP is running. may be.)

	bsf	MyIdCont_Flag, 0	;; set MyIdCont_Flag=1 

	call	ResetBusOnOut		;; BusOnOut OFF	   Apr. 05 2004
	call	LED_OFF			;; LED light OFF
	call	StoreEEPROM		;; Store various values into EEPROM

	bsf	Sleeping, 0		;; set Sleeping=1 (sleeping)
	clrwdt				;; WDT clear
	sleep				;; go PIC-sleep
	nop				;; --- wake up ---
	nop				;; 
	nop				;; <INT activates here>
	nop				;;

;;---NOTE
;; Sleeping flag (00:running, 01:sleepig, 02:wakeup)
;; is set to "01" while going into sleep (herein this function), 
;; and is set to "02" while wakeup in RB0/INT(BusOn high is re-detected) (T)

	movf	Sleeping, 0	;; check whether I'm just in a "wakeup".
	xorlw	0x00			;; 00:running, 01:sleepig, 02:wakeup
	btfsc	STATUS, Z
	goto	SystemSetup		;; If "running", go SystemReset 
					;; (because something is wrong...)
	movf	Sleeping, 0		
	xorlw	0x01
	btfsc	STATUS, Z
	goto	Resume			;; DEBUG - under consideration....

	movf	Sleeping, 0
	xorlw	0x02
	btfsc	STATUS, Z
	goto	Resume			;; If it's just wakeup, go resume.

	goto	Cmd_PowerOff2		;;(stopper)

Cmd_Deselected:
	movf	Cmd2, 0			; ensure it's the right ID
	subwf	MyId, 0
	btfsc	STATUS, Z
	goto	Cmd_Selected2		; actually it's me selected

	call	Play_Stop		;; Stop Playing.
	call	Waitfor15
	call	Play_Stop		;; retry.

	movlw	DispCtrl_Inform
	movwf	DispCtrl		;;

	goto	ReceiveBreak		;; 


;;--- [10db00xx] State Monitoring into Internal MD  ;; Jul 24 2004
PongEject:				
	IFDEF	Internal_MD	
;;---------------------------
	movf	Tad, 0
	andlw	0xf0			;; Tad is in MD group
	xorlw	0xd0			;; (0xd0)
	btfss	STATUS, Z

	goto	ReceiveBreak
					;; case Tad=0xdb(on MDX-5V101R),
	movf	Display, 0		;; check Display=0 or 16.. (Not Playing)
	andlw	0x0f
	xorlw	0x00
	btfss	STATUS, Z		
	goto	ReceiveBreak		;; case Playing, exit.

	movf	MyGroup, 0		;; MyGroup -> W
	xorlw	0xd0
	btfss	STATUS, Z		;;
	goto	ReceiveBreak		;; case I'm Not MD, exit.

	movf	Cmd2, 0			;; case Not Playing
	movwf	MD11State		;; Store MD11State
	xorlw	0x00			;; check MD11 is in Playing
	btfsc	STATUS, Z
	goto	SetIDS_ejecting

	movf	MD11State, 0		;; MD11State -> W
	xorlw	0xC0			
	btfsc	STATUS, Z		;; check MD11 is in Ejecting
	goto	SetIDS_idle

	goto	ReceiveBreak		;; else, exit

SetIDS_ejecting:
	movlw	0xC0			;; set dongle is in Ejecting.
	movwf	IdleState		;; 

	btfsc	Ej_announceF, 0
	goto	ReceiveBreak		;; if already set, then exit.

					;; (if not set)
	bsf	Ej_announceF ,0		;; set Ej_announceF=1

	clrf	PowDown			;; One time power up...
	movlw	0x20
	movwf	Display			;; set Display=32
	call	IssueSlaveBreak

	goto	ReceiveBreak

SetIDS_idle:
	movlw	0x80			;; set dongle is in Idle
	movwf	IdleState		;; 
	clrf	Ej_announceF		;; set Ej_announceF=0
;;---------------------------
	ENDIF	;;<Internal_MD>

	goto	ReceiveBreak


;;--- Toggle status of DSPL Button	;; Mar. 07 2004 (T)
But_DSPL2:				;; [0x2960]   for MDX-5V101R(AS)
					;; [0x5000]   for MDX-61(Enter)

	movf	DisplayMode, 0		;;
	xorlw	Show_DcName		;; check  DisplayMode = DiscName?
	btfss	STATUS, Z
	goto	ReceiveBreak		;; not Show_DcName, Abort.

					;; (case Show_DcName)
	btfsc	DSPL_Run, 0		;; check DSPL_Run flag = ON?
	goto	ReceiveBreak		;; case =ON, Abort.

					;; (case Show_DcName & DSPL_Run=OFF),
	movf	Display, 0		
	xorlw	0x00			;; Playing or Not?
	btfsc	STATUS, Z
	goto	ReceiveBreak		;; case Idle, goto RB

	goto	Toggle_DSPL		;;

	goto	ReceiveBreak		;; (Stopper)


;;---  Switch the Disk0-Disk9 from Disk0x_def to Disk1x_def
;;      set "<AUX-IN>  "  by default.
Toggle_DSPL:
	incf	DSPL_ToggleC, 1

	btfss	DSPL_ToggleC, 0		;; check 0bit position
	goto	Toggle_DSPL0		;; case Bit=0
	goto	Toggle_DSPL1		;; case Bit=1

Toggle_DSPL0:
	movlw	DiscNamADDR0		;; EEPROM:0x2120
	movwf	DiscNamADDR

	movlw	TrackNamADDR0		;; EEPROM:0x2140
	movwf	TrackNamADDR

	movlw	DispCtrl_DcName
	movwf	DispCtrl	
	goto	But_DSPL_Ent2

Toggle_DSPL1:
	movlw	DiscNamADDR1		;; EEPROM:0x2130
	movwf	DiscNamADDR

	movlw	TrackNamADDR1		;; EEPROM:0x2140
	movwf	TrackNamADDR
	
	movlw	DispCtrl_DcName
	movwf	DispCtrl	
	goto	But_DSPL_Ent2

But_Next:				;;[0x2960] AS button (pressed)
	movf	Display, 0
	andlw	0x0f			;; result -> W
	xorlw	0x00
	btfss	STATUS, Z		;; check Display=0 or 16
	goto	But_DSPL2P		;; case Playing, toggle DiscName

	IFDEF	NextNext
;; ---NEXT NEXT --			;; Apr.18 2004  (T)
	movf	Cmd2, 0			;; case Not Playing(Display=0), 
					;; check Cmd2
	xorlw	0x60			
	btfsc	STATUS, Z		;; ([0x2960]: AS Button pressed)
	goto	Next_Next		;; 
;; ---------------
	ENDIF	;;<NextNext>

	goto	ReceiveBreak		;; not [0x2960], goto RB.

But_DSPL2P:				;; case Playing, toggle DiscName
	movf	Cmd2, 0			;; 
					;; check Cmd2
	xorlw	0x60			;; ([0x2960]: AS Button pressed)
	btfsc	STATUS, Z		
	goto	But_DSPL2		;; toggle DiscName

	goto	ReceiveBreak		;; else, goto RB.

	IFDEF	NextNext
;; ---NEXT NEXT --
Next_Next:				;; case [0x296a]
	movf	CurDiscNum, 0		;; check CurDiscNum = not null.
	xorlw	0x00			;; 
	btfsc	STATUS, Z
	goto	ReceiveBreak		;; (CurDiscNum=0) Do nothing.

	movf	CurSource, 0		;; case CD_1
	xorlw	0x31
	btfsc	STATUS, Z
	call	GoNext_Cd		;; May. 4 2004 (T)

	movf	CurSource, 0		;; case MD_1
	xorlw	0xd1
	btfsc	STATUS, Z
	call	GoNext_Md		;; May. 4 2004 (T)

	movf	CurSource, 0		;; case CD_2
	xorlw	0x32
	btfsc	STATUS, Z
	call	GoNext_Cd		;; May. 4 2004 (T)

	movf	CurSource, 0		;; case MD_2
	xorlw	0xd2
	btfsc	STATUS, Z
	call	GoNext_Md		;; May. 4 2004 (T)

	goto	ReceiveBreak		;; else, do Nothing(ex 0xdb..).

GoNext_Cd:				;; May. 4 2004 (T)
	call	GetMag_Cd
	goto	Next_Next2
	
GoNext_Md:				;; May. 4 2004 (T)
	call	GetMag_Md
	goto	Next_Next2

Next_Next2:
	btfss	DDir_Flag, 0		;; DDir_Flag = 0x01 ?
	goto	Next_Next2skip		;; case Not set, skip

	movf	DDir_Num, 0		;; case flag is set,
	movwf	CurDiscNum		;; DDir_Num -> CurDiscNum
	clrf	DDir_Flag		;; clear DDir_Flag


Next_Next2skip:
	movf	CurDiscNum, 0		;; (Max DiscNum = 10 (0x0a))
	subwf	SlotOfMagP, 0		;; SlotOfMag - CurDiscNum -> W
					;;
	btfss	STATUS, C
	clrf	CurDiscNum		;; CurDiscNum=0
					;; else NOP

	incf	CurDiscNum, 1		;; CurDiscNum+1 -> CurDiscNum.
	swapf	CurDiscNum, 0		;; swapf(CurDiscNum) -> W

	movwf	NewDiscNumP		;; New Disc Number (Pressed)
	addlw	0x0a
	movwf	NewDiscNumR		;; New Disc Number (Released)

	clrf	PowDown			;; One time power up... (Display=16)

	movlw	0x10			;; set Next State Number=16
	movwf	Display

	call	IssueSlaveBreak

	goto	ReceiveBreak

;; ----------------------
	ENDIF	;;<NextNext>

	IFDEF	DEBUG
;;--------------------------
But_Next_Test:				;; for Testing (for MDX-61)
	movf	Display, 0
	andlw	0x0f			;; result -> W
	xorlw	0x00
	btfss	STATUS, Z		;; check Display=0 or 16
	goto	But_DSPL3P		;; case Playing, toggle DiscName

	IFDEF	NextNext
;; ---NEXT NEXT --			;;
	movf	Cmd2, 0			;; case Not Playing(Display=0,16), 
					;; check Cmd2
	xorlw	0x00			;; ([0x5000]: Enter Button pressed)
	btfsc	STATUS, Z		
	goto	Next_Next		;;
;; ---------------
	ENDIF	;;<NextNext>

	goto	ReceiveBreak		;; not [0x5000], goto RB.

But_DSPL3P:				;; case Playing, toggle DiscName
	movf	Cmd2, 0			;; 
					;; check Cmd2
	xorlw	0x00			;; ([0x5000]: AS Button pressed)
	btfsc	STATUS, Z		
	goto	But_DSPL2		;; toggle DiscName

	goto	ReceiveBreak		;; else, goto RB.

;;----------------------------
	ENDIF	;; <DEBUG>

Current_DiscP:
	movf	Tad, 0			;; Tad -> W
	andlw	0xf0
	xorlw	0x30
	btfsc	STATUS, Z
	goto	Current_Disc		;; case CD

	movf	Tad, 0			;; Tad -> W
	andlw	0xf0
	xorlw	0xd0
	btfsc	STATUS, Z
	goto	Current_Disc		;; case MD

	goto	ReceiveBreak		;; else

Current_Disc:
	movf	Display, 0
	andlw	0x0f			;; result -> W
	xorlw	0x00
	btfss	STATUS, Z		;; check Display=0 or 16

	goto	ReceiveBreak		;; case Playing, do Nothing

					;; case Not Playing(Display=0,16), 
	movf	Cmd2, 0			;; check Cmd2
	xorlw	0x00			;; ([0x70id9000]: Current Playin Pos)
	btfsc	STATUS, Z		
	goto	Current_Disc2

	movf	Cmd2, 0			;; check Cmd2
	xorlw	0x40			;; ([0x70id9040]: Current Playin Pos)
	btfsc	STATUS, Z		
	goto	Current_Disc2

	goto	ReceiveBreak		;; else

Current_Disc2:
	swapf	Data14, 0		;;
	andlw	0x0f			;;
	movwf	CurDiscNum		;; store Current DiscNum -> CurDiscNum

	movf	Tad, 0			;; get Current CD/MD Source ID
	movwf	CurSource		;; store Current Source ID

	clrf	DDir_Flag		;; clear DDir_Flag

	goto	ReceiveBreak		;; goto RB.

Current_Disc3:
	movf	Display, 0
	andlw	0x0f			;; result -> W
	xorlw	0x00
	btfss	STATUS, Z		;; check Display=0 or 16
	goto	ReceiveBreak		;; case Playing, do Nothing
					;; case Not Playing(Display=0,16), 

	movf	Cmd2, 0			;; check Cmd2
	xorlw	0x00			;; ([0x70idc000xxxxxxxxxxxxxxxxNx]
	btfsc	STATUS, Z		
	goto	Current_Disc4

	movf	Cmd2, 0			;; check Cmd2
	xorlw	0x20			;; ([0x70idc020xxxxxxxxxxxxxxxxNx]
	btfsc	STATUS, Z		
	goto	Current_Disc4

	goto	ReceiveBreak		;; else

Current_Disc4:
	swapf	Data25, 0		;;
	andlw	0x0f			;;
	movwf	CurDiscNum		;; store Current DiscNum -> CurDiscNum

	movf	Tad, 0			;; get Current CD/MD Source ID
	movwf	CurSource		;; store Current Source ID

	clrf	DDir_Flag		;; clear DDir_Flag

	goto	ReceiveBreak		;; goto RB.


Magazine_Info:				;; [0x70,id,95,xx,xx,xx,xx,xN]
	movf	Display, 0
	andlw	0x0f			;; result -> W
	xorlw	0x00
	btfss	STATUS, Z		;; check Display=0 or 16
	goto	ReceiveBreak		;; case Playing, do Nothing
					;; case Not Playing(Display=0,16), 
	movf	Data14, 0		;; 
	andlw	0x0f			;; Number of slot in this magazine

	btfsc	STATUS, Z		;; 
	goto	ReceiveBreak		;; if Number of slot = 0, then NOP

	movwf	SlotOfMag		;; W -> SlotOfMag
	decf	SlotOfMag, 1		;; SlotOfMag - 1 -> SlotOfMag

	movf	Tad, 0
	andlw	0xf0
	xorlw	0x30			;; case Tad is CD(=0x3X)
	btfsc	STATUS, Z
	goto	SetMag_Cd		;; store SlotOfMag to SlotOfMg_Cd

	movf	Tad, 0
	andlw	0xf0
	xorlw	0xd0			;; case Tad is MD(=0xdX)
	btfsc	STATUS, Z
	goto	SetMag_Md		;; store SlotOfMag to SlotOfMg_Md

	goto	ReceiveBreak		;; goto RB. (stopper)

SetMag_Cd:
	movf	SlotOfMag, 0
	movwf	SlotOfMg_Cd

	goto	ReceiveBreak		;;
	
SetMag_Md:
	movf	SlotOfMag, 0
	movwf	SlotOfMg_Md

	goto	ReceiveBreak		;;


GetMag_Cd:
	movf	SlotOfMg_Cd, 0
	movwf	SlotOfMagP		;; SlotOfMg_Cd -> SlotOfMagP
	xorlw	0x05
	btfsc	STATUS, Z
	return				;; set SlotOfMagP = 5

	movf	SlotOfMg_Cd, 0		;; SlotOfMg_Cd -> SlotOfMagP
	movwf	SlotOfMagP
	xorlw	0x09
	btfsc	STATUS, Z
	return				;; set SlotOfMagP = 9
					;; else,
	call	GetMag_Cd_EPROM		;; result -> W
	xorlw	0x09			;; check SlotOfMg_Cd = 9
	movlw	0x05			;; case Not 9, set 5
	btfsc	STATUS, Z
	movlw	0x09			;; case 9
	movwf	SlotOfMagP		;; store  W -> SlotOfMagP
	return

GetMag_Md:
	movf	SlotOfMg_Md, 0
	movwf	SlotOfMagP		;; SlotOfMg_Md -> SlotOfMagP
	xorlw	0x05
	btfsc	STATUS, Z
	return				;; set SlotOfMagP = 5

	movf	SlotOfMg_Md, 0		;; SlotOfMg_Md -> SlotOfMagP
	movwf	SlotOfMagP
	xorlw	0x09
	btfsc	STATUS, Z
	return				;; set SlotOfMagP = 9
					;; else,
	call	GetMag_Md_EPROM		;; result -> W
	xorlw	0x09			;; check SlotOfMg_Cd = 9
	movlw	0x05			;; case Not 9, set 5
	btfsc	STATUS, Z
	movlw	0x09			;; case 9
	movwf	SlotOfMagP		;; store  W -> SlotOfMagP
	return

GetMag_Cd_EPROM:
	movlw	MagCD_EEADR		;; EEPROM ADDR for Mag_CD(0x10)
	call	Eeprom_Read		;; Result -> W
	return

GetMag_Md_EPROM:
	movlw	MagMD_EEADR		;; EEPROM ADDR for Mag_MD(0x11)
	call	Eeprom_Read		;; Result -> W
	return


StoreMag_Cd_EPROM:		;;-- set value onto Work before you call this.
	movwf	ee_data			;; W -> EE_Data
	movlw	MagCD_EEADR		;; EEPROM ADDR for Mag_CD(0x10)
	call	Eeprom_Write
	return

StoreMag_Md_EPROM:		;;-- set value onto Work before you call this.
	movwf	ee_data			;; W -> EE_Data
	movlw	MagMD_EEADR		;; EEPROM ADDR for Mag_MD(0x11)
	call	Eeprom_Write
	return

DDirNum_Store:				;; [0x10,21,3c,Na] 
	movf	Rad, 0			;; Rad = 10?
	xorlw	0x10
	btfss	STATUS, Z
	goto	ReceiveBreak		;; if not, goto RB

	movf	Tad, 0			;; Tad = 21?
	xorlw	0x21
	btfss	STATUS, Z
	goto	ReceiveBreak		;; if not, goto RB

	swapf	Cmd2, 0			;; swap Cmd2
	andlw	0x0f			
	movwf	DDir_Num		;; store Cmd2 -> DDir_Num

	bsf	DDir_Flag, 0		;; set = 1

	goto	ReceiveBreak		;;

;;---				;; Request to send Extra Disc/Track Name
ExtraNam_Req:			;; [MyID,71,84,dd/d9,70,field,00,02] 
	movf	Rad, 0			;; 
	subwf	MyId, 0			;; Is Rad MyID?
	btfss	STATUS, Z
	goto	ReceiveBreak		;; (Not MyID) Exit.

	movf	MyGroup, 0		;; 
	xorlw	0xd0
	btfss	STATUS, Z
	goto	ReceiveBreak		;; (case Not MD) Exit.

					;; case MD
	movf	Data12, 0
	movwf	Dsp_Field		;; store field number 

	movf	Cmd2, 0			;; check Cmd2 0xd9 or 0xdd ?
	xorlw	0xd9
	btfsc	STATUS, Z		;; case 0xd9
	goto	Extra_TrackName		;; goto Extra_TrackName

	movf	Cmd2, 0			;; check Cmd2 0xd9 or 0xdd ?
	xorlw	0xdd
	btfsc	STATUS, Z		;; case 0xdd
	goto	Extra_DiscName		;; goto Extra_DisoName

	goto	ReceiveBreak		;; else, RB

Extra_TrackName:			;; Max Dsp_Field is limited to "00"-"07"
	movf	Dsp_Field, 0
	sublw	0x07
	btfss	STATUS, C
	goto	ReceiveBreak		;; C=0 (neg: out of range)
				
	movlw	0x0a			;; C=1 (pos: within 02 to 07)
	movwf	Display			;; set Display=0x0a

	bsf	ResPeriod, 0		;; set ResPeriod = 1
	call	IssueSlaveBreak		;; call ISB
	
	goto	ReceiveBreak		; Done, wait for next command

Extra_DiscName:				;; Max Dsp_Field is limited to "00"-"03"
	movf	Dsp_Field, 0
	sublw	0x03
	btfss	STATUS, C
	goto	ReceiveBreak		;; C=0 (neg: out of range)
				
	movlw	0x0c			;; C=1 (pos: within 02 to 03)
	movwf	Display			;; set Display=0x0c

	bsf	ResPeriod, 0		;; set ResPeriod = 1
	call	IssueSlaveBreak		;; call ISB
	
	goto	ReceiveBreak		; Done, wait for next command


;;-- 					;; Reload DiscName and TrackName
Cmd_DSP_Shows:				;; when 'Display Shows' comes.
	movf	Display, 0
	andlw	0x0f			;; result -> W
	xorlw	0x00
	btfsc	STATUS, Z		;; check Display=0 or 16

	goto	ReceiveBreak		;; case Not Playing, exit

					;; case Playing
	movf	Cmd2, 0			;; check Cmd2
	andlw	0x0f
	xorlw	0x09			;; 18,xx,80,x9
	btfss	STATUS, Z		

	goto	ReceiveBreak		;; else, exit

	movf	Cmd2, 0			;;
	movwf	DisplayMode		;; Cmd2 -> DisplayMode

	movlw	DispCtrl_Inform
	movwf	DispCtrl

	clrf	DSPL_Run		;; initialize DSPL_Run

	goto	But_DSPL_Ent2		;; Reload DiscName and TrackName


;;*****************************************************************************
StoreEEPROM:				;; Store various values into EEPROM
;;--Store Number of Magazine slots
StoreMagCd:
	movf	SlotOfMg_Cd, 0		;; SlotOfMg_Cd -> W
	xorlw	0x05
	btfsc	STATUS, Z
	goto	SetMag_Cd2		;; case 5

	movf	SlotOfMg_Cd, 0		;; SlotOfMg_Cd -> W
	xorlw	0x09
	btfsc	STATUS, Z
	goto	SetMag_Cd2		;; case 9

	goto	StoreMagMd		;; Skip EEPROM write

SetMag_Cd2:
	call	GetMag_Cd_EPROM		;; result -> W
	xorwf	SlotOfMg_Cd, 0		;; 
	btfsc	STATUS, Z		;;
	goto	StoreMagMd		;; Skip EEPROM write
					;; else, 
	movf	SlotOfMg_Cd, 0		;; SlotOfMg_Cd -> W
	call	StoreMag_Cd_EPROM	;; Store to EEPROM
	call	Waitfor15

StoreMagMd:
	movf	SlotOfMg_Md, 0		;; SlotOfMg_Md -> W
	xorlw	0x05
	btfsc	STATUS, Z
	goto	SetMag_Md2		;; case 5

	movf	SlotOfMg_Md, 0		;; SlotOfMag -> W
	xorlw	0x09
	btfsc	STATUS, Z
	goto	SetMag_Md2		;; case 9

	goto	StoreDsplMode		;; Skip EEPROM write

SetMag_Md2:
	call	GetMag_Md_EPROM		;; result -> W
	xorwf	SlotOfMg_Md, 0		;; 
	btfsc	STATUS, Z		;;
	goto	StoreDsplMode		;; Skip EEPROM write
					;; else, 
	movf	SlotOfMg_Md, 0		;; SlotOfMag -> W
	call	StoreMag_Md_EPROM	;; Store to EEPROM
	call	Waitfor15

;;--Store DisplayMode
StoreDsplMode:
	movlw	DsplMode_EEADR		;; EEPROM ADDR for Disply Mode
	call	Eeprom_Read		;; Result -> W

	xorwf	DisplayMode, 0		;; W = DisplayMode ?
	btfsc	STATUS, Z		;;
	goto	StoreToggleC		;; if the same mode, Skip.
					;; else, 
	movf	DisplayMode, 0		;; DisplayMode -> W
	movwf	ee_data			;; W -> EE_Data
	movlw	DsplMode_EEADR		;; EEPROM ADDR for Display Mode
	call	Eeprom_Write
	call	Waitfor15

;;--Store DSPL_ToggleC
StoreToggleC:
	movlw	DsplTglC_EEADR		;; EEPROM ADDR for DSPL_ToggleC
	call	Eeprom_Read		;; Result -> W

	movf	DSPL_ToggleC, 0		;; W = DSPL_ToggleC ?
	btfsc	STATUS, Z		;;
	goto	SkipTglCEwrite		;; if the same mode, Skip.
					;; else, 
	movf	DSPL_ToggleC, 0
	movwf	ee_data			;; W -> EE_Data
	movlw	DsplTglC_EEADR		;; EEPROM ADDR for Toggle on Disc Name
	call	Eeprom_Write
	call	Waitfor15

SkipTglCEwrite:
	nop
	return

;;*****************************************************************************

;; --------End of parse.asm
